/**************************************************************************
*
*	pchardrep.fs    
*
*	FORM:	pchardrep      
*	DESCRIPTION:	This report is used to print reports on
*			records from the PC Hardware database.
*
*	AUTHOR:    Unknown  (Modified by JWS)
*	DATE:      Unknown
*	REVIEWER:  Unknown
*
****************************************************************************/

#define set_select(prevf,curf,fieldname) \
   SET curf:fieldname:SEARCH_RANGES TO prevf:fieldname:SEARCH_RANGES

FORM pchardrep       

TARGET_TABLE pchard

LOCAL sel,printer

BEFORE FORM
   SET pchardrep:sel:STOP_FOR_INPUT TO TRUE
   SET pchardrep:FIRST_FIELD TO 'sel'
   SET pchardrep:AUTO_FIND TO TRUE   
   SET sel TO UNDEFINED
   SET printer TO getenv$('SPOOLER')

BEFORE FIND
   IF pchardrep:PREV_FORM = 'pchard' THEN
   BEGIN
     set_select(pchard,pchardrep,ph_node)
     set_select(pchard,pchardrep,ph_lnum) 
     set_select(pchard,pchardrep,ph_ven) 
     set_select(pchard,pchardrep,ph_mod) 
     set_select(pchard,pchardrep,ph_sn) 
     set_select(pchard,pchardrep,ph_slot)
   END
   IF sel = 2 THEN
   BEGIN
      CREATE PIPELINE pchardrep:pipe1 'RPT /usr/db/ACL4/rptdir/pchard.r -',
        printer;
      DISPLAY 'Creating Pipeline' FOR FYI_MESSAGE;
   END

ON FIND
   IF sel = 2 THEN
      WRITE PIPELINE pchardrep:pipe1 ph_node,ph_ven,ph_mod,ph_sn,ph_slot

AFTER FIND
   IF sel = 2 THEN
   BEGIN
      CLOSE PIPELINE pchardrep:pipe1;
      DISPLAY 'Printing Report on selected records. Hit RETURN to continue.'
         FOR FYI_MESSAGE WAIT;
      SET sel TO UNDEFINED
   END

FIELD sel
   ON FIELD
      REFRESH SCREEN
      INPUT
      SWITCH sel
      BEGIN
         CASE 1:
            BEGIN
               CREATE PIPELINE pchardrep:pipe1 'RPT /usr/db/ACL4/rptdir/pchard.r -',
                  printer
               WRITE PIPELINE pchardrep:pipe1 ph_node, ph_ven, ph_mod,
                  ph_sn, ph_slot
               CLOSE PIPELINE pchardrep:pipe1;
               DISPLAY 'Done printing record.  Hit RETURN.' FOR FYI_MESSAGE
                  WAIT;
               SET sel TO UNDEFINED
            END
         CASE 2:
            BEGIN
               DISPLAY 'Printing Report on selected records.' FOR FYI_MESSAGE;
               NEXT ACTION IS FIND
            END
         DEFAULT:
            BEGIN 
               DISPLAY 'Enter either 1 or 2.' FOR FYI_MESSAGE WAIT;
               RESTART ON FIELD
            END
      END
